# Supported algorithms

ACL aims to support a few core algorithms that are well suited for production use and other algorithms that are interesting to compare against.

*  [Uniformly sampled](algorithm_uniformly_sampled.md)

# How to integrate the library

*  [Handling asserts](handling_asserts.md)
*  [Implementing an allocator](implementing_an_allocator.md)
*  [Creating a skeleton](creating_a_skeleton.md)
*  [Creating a raw clip](creating_a_raw_clip.md)
*  [Compressing a raw clip](compressing_a_raw_clip.md)
*  [Decompressing a clip](decompressing_a_clip.md)
*  [Creating a raw track list](creating_a_raw_track_list.md)
*  [Compressing scalar tracks](compressing_scalar_tracks.md)
*  [Decompressing scalar tracks](decompressing_a_track_list.md)
*  [Other considerations](misc_integration_details.md)

See how it's integrated into Unreal Engine 4 [here](https://github.com/nfrechette/acl-ue4-plugin)!

# Performance metrics

*  [Carnegie-Mellon University database performance](cmu_performance.md)
*  [Paragon database performance](paragon_performance.md)
*  [Matinee fight scene performance](fight_scene_performance.md)
*  [Decompression performance](decompression_performance.md)

# Research

*  [Arithmetic accuracy](research_arithmetic_accuracy.md)

# Miscellaneous

*  [The ACL file format](the_acl_file_format.md)
*  [Rotation and vector formats](rotation_and_vector_formats.md)
*  [Range reduction](range_reduction.md)
*  [Error metrics](error_metrics.md)
*  [Performance graph generation](graph_generation.md)
